//+------------------------------------------------------------------+
//|                                                        Ich_1.mq5 |
//|                                                            Graff |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Graff"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- input parameters
input int      TenkanSen=9;
input int      KijunSen=26;
input int      SenkoSpan=52;
//uint ichi_h=0;
#include <Indicators\Trend.mqh>
CiIchimoku ichi;

#include <ChartObjects\ChartObjectsArrows.mqh>
CChartObjectArrowDown down;
CChartObjectArrowUp up;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   //ichi=new CiIchimoku();
   ichi.Create(_Symbol,_Period,TenkanSen,KijunSen,SenkoSpan);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   //delete ichi;
   //up.Detach();
   //down.Detach();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   for(int i=0; i<=TerminalInfoInteger(TERMINAL_MAXBARS)-1; i++)
     {
      if(ichi.TenkanSen(i)<ichi.KijunSen(i))
        {
         up.Create(0,"Tenkan>Kijun"+IntegerToString(i),0,time[i],low[i]);
         up.Color(clrLimeGreen);
        }
      else
        {
         down.Create(0,"Tenkan<Kijun"+IntegerToString(i),0,time[i],high[i]);
         down.Color(clrTomato);
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
